int cycle_counter=0;

int old_open=0;
int old_close=0;
int old_gatesensor=0;
int old_movement=0;

int old_buttonopen=0;
int old_buttonclose=0;

char buf[80];

void sendHTTPRequest() {
  Serial.println(buf); 
}


void setup()
{

 pinMode(2, INPUT); // Датчик открытых ворот
 old_open=digitalRead(2);

 pinMode(3, INPUT); // Датчик закрытых ворот
 old_close=digitalRead(3);

 pinMode(4, INPUT); // Датчик пересечения проема ворот
 old_gatesensor=digitalRead(4);

 pinMode(5, INPUT); // Датчик движения во дворе
 old_movement=digitalRead(5);

 pinMode(6, INPUT); // Кнопка открыть ворота
 old_buttonopen=digitalRead(6);

 pinMode(7, INPUT); // Кнопка закрыть ворота
 old_buttonclose=digitalRead(7);
 
 pinMode(8, OUTPUT);
 digitalWrite (8,HIGH);
 pinMode(9, OUTPUT);
 digitalWrite (9,HIGH); 

 Serial.begin(9600); 
}

void loop()
{

  int valid_sensor=0;

  delay(100); // задержка в 0.1 сек.  
  cycle_counter++;

  if (cycle_counter>600) {
    cycle_counter=0;
  }    

  //GATES OPEN SENSOR
  Serial.println("GO");
  int current_open=digitalRead(2);
  //Serial.println(old_open);
  if (current_open!=(int)old_open) {
    old_open=(int)current_open;
    sprintf(buf, "GET /objects/?object=GateOpen&op=m&m=statusChanged&status=%i HTTP/1.0", (int)current_open);
    sendHTTPRequest();
  }

 //GATES CLOSE SENSOR

  Serial.println("GC");
  int current_close=digitalRead(3);
  //Serial.println(current_close);
  if (current_close!=(int)old_close) {
    old_close=(int)current_close;
    sprintf(buf, "GET /objects/?object=GateClose&op=m&m=statusChanged&status=%i HTTP/1.0", (int)current_close);
    sendHTTPRequest();
  }

 //GATE SENSOR
  Serial.println("GS");
  int current_gatesensor=digitalRead(4);
  //Serial.println(current_gatesensor);
  if (current_gatesensor!=(int)old_gatesensor) {
    old_gatesensor=(int)current_gatesensor;
    sprintf(buf, "GET /objects/?object=GateSensor&op=m&m=statusChanged&status=%i HTTP/1.0", (int)current_gatesensor);
    sendHTTPRequest();
  }

 //MOVEMENT SENSOR
  Serial.println("M1");
  int current_movement=digitalRead(5);
  //Serial.println(current_movement);
  if (current_movement!=(int)old_movement) {
    old_movement=(int)current_movement;
    sprintf(buf, "GET /objects/?object=SesorMove&op=m&m=statusChanged&status=%i HTTP/1.0", (int)current_movement);
    sendHTTPRequest();
  }


//BUTTON OPEN
  Serial.println("BO");
  int current_buttonopen=digitalRead(6);
  if (current_buttonopen!=(int)old_buttonopen && current_buttonopen==1) {
	delay(2000);
	int current_buttonopen=digitalRead(6);
	if (current_buttonopen==1) {
	 // long press
     sprintf(buf, "GET /objects/?object=BottomOpen&op=m&m=statusChanged&status=%i HTTP/1.0", 2);	 
	} else {
	 // click
     sprintf(buf, "GET /objects/?object=BottomOpen&op=m&m=statusChanged&status=%i HTTP/1.0", 1);	 
	}
	old_buttonopen=(int)current_buttonopen;
    sendHTTPRequest();
  }

//BUTTON CLOSE
  Serial.println("BC");
  int current_buttonclose=digitalRead(7);
  if (current_buttonclose!=(int)old_buttonclose && current_buttonclose==1) {
	delay(2000);
	int current_buttonclose=digitalRead(7);
	if (current_buttonclose==1) {
	 // long press
     sprintf(buf, "GET /objects/?object=BottomClose&op=m&m=statusChanged&status=%i HTTP/1.0", 2);	 
	} else {
	 // click
     sprintf(buf, "GET /objects/?object=BottomClose&op=m&m=statusChanged&status=%i HTTP/1.0", 1);	 
	}
	old_buttonclose=(int)current_buttonclose;
    sendHTTPRequest();
  } 
 String content = "";
  char character;

  while (Serial.available()) {
    character = Serial. read();
    content. concat (character);
    delay (10);
  } 
  if (content.length() > 0) {
    if (content.equals("RelayOpenON")) {
    digitalWrite (8, LOW);
  }
    
  if (content.equals("RelayOpenOFF")) {
      digitalWrite (8,HIGH);
  }
  if (content.equals("RelayCloseOFF")) {
      digitalWrite (9,HIGH);   
  }
  if (content.equals("RelayCloseON")) {
      digitalWrite (8,LOW);  
  }  
 
}
}

